#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
import                                  _winreg
import mx.ODBC.Windows as               odbc
OperationalError                        = odbc.OperationalError
E                                       = g.configtool.utilities.IOU.E
#-----------------------------------------------------------------------------------------------------------
#   Query                           = g.tipsy_Query
#   tipsyStore                      = g.tipsy_tipsyStore
#   cfg                                     = g.cfg
#   docrefs                                 = g.docrefs
#   fsi                                     = g.filesystemIdioms
#   h                                       = g.hm.h
#   ontonymResolver                         = g.reprom.xindicators
#   widgets                                 = g.widgets
#   U                                       = g.configtool.utilities.IOU.U
#   E                                       = g.configtool.utilities.IOU.E
S                                       = g.configtool.utilities.EzSet.S
#-----------------------------------------------------------------------------------------------------------



#   class Metasql:
#
#       def tables( self ):
#           return """select * from information_schema.tables"""
#
#       def columns( self ):
#           return """select TABLE_NAME, COLUMN_NAME, DATA_TYPE, CHARACTER_SET_NAME from information_schema.columns"""
#
#   metasql = Metasql()


############################################################################################################
#
#
#
#===========================================================================================================
class DescriptionMx( object ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self ):
        pass

############################################################################################################
#
#
#
#===========================================================================================================
class SortedItervaluesDict( dict ):

    #-------------------------------------------------------------------------------------------------------
    def keys( self ):
        R = super( SortedItervaluesDict, self ).keys()
        R.sort()
        return R

    #-------------------------------------------------------------------------------------------------------
    def iterkeys( self ):
        for R in self.keys():
            yield key

    #-------------------------------------------------------------------------------------------------------
    def itervalues( self ):
        for key in self.keys():
            yield self[ key ]

    #-------------------------------------------------------------------------------------------------------
    def iteritems( self ):
        for key in self.keys():
            yield key, self[ key ]

    #-------------------------------------------------------------------------------------------------------
    def items( self ):
        return list( self.iteritems() )

    #-------------------------------------------------------------------------------------------------------
    def values( self ):
        return list( self.values() )

    #-------------------------------------------------------------------------------------------------------
    def __iter__( self ):
        return self.itervalues()

############################################################################################################
#
#
#
#===========================================================================================================
class TableDescription( DescriptionMx, SortedItervaluesDict ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, TABLE_CAT, TABLE_SCHEM, TABLE_NAME, TABLE_TYPE, REMARKS, *P ):
        super( TableDescription, self ).__init__()
        self.catalog        = TABLE_CAT
        self.schema         = TABLE_SCHEM
        self.name           = TABLE_NAME
        self.type           = TABLE_TYPE
        self.description    = REMARKS
        #self.additional     = P


############################################################################################################
#
#
#
#===========================================================================================================
class ColumnDescription( DescriptionMx ):

    """

    The following list explains the columns returned by the mxODBC ``cursor.columns()`` method (in the order
    these columns are returned). All this information can be stored in the ``ColumnDescription`` instance,
    but only part of it is currently represented. Where this is the case, the name of the attributer is
    added in parentheses. Explanations have been copied from
    http://msdn.microsoft.com/library/en-us/odbc/htm/odbcsqlcolumns.asp, which see for references.

    ``COLUMN_NAME`` (``name``)
        Column name. The driver returns an empty string for a column that does not have a name.

    ``DATA_TYPE``
        SQL data type. This can be an ODBC SQL data type or a driver-specific SQL data type. For datetime
        and interval data types, this column returns the concise data type (such as SQL_TYPE_DATE or
        SQL_INTERVAL_YEAR_TO_MONTH, rather than the nonconcise data type such as SQL_DATETIME or
        SQL_INTERVAL). For a list of valid ODBC SQL data types, see SQL Data Types in Appendix D: Data
        Types. For information about driver-specific SQL data types, see the driver's documentation.

        The data types returned for ODBC 3.x and ODBC 2.x applications may be different. For more
        information, see Backward Compatibility and Standards Compliance.

    ``TYPE_NAME``
        Data source–dependent data type name; for example, "CHAR", "VARCHAR", "MONEY", "LONG VARBINAR", or
        "CHAR ( ) FOR BIT DATA".

    ``COLUMN_SIZE``
        If DATA_TYPE is SQL_CHAR or SQL_VARCHAR, this column contains the maximum length in characters of
        the column. For datetime data types, this is the total number of characters required to display the
        value when converted to characters. For numeric data types, this is either the total number of
        digits or the total number of bits allowed in the column, according to the NUM_PREC_RADIX column.
        For interval data types, this is the number of characters in the character representation of the
        interval literal (as defined by the interval leading precision, see Interval Data Type Length in
        Appendix D: Data Types). For more information, see Column Size, Decimal Digits, Transfer Octet
        Length, and Display Size in Appendix D: Data Types.

    ``BUFFER_LENGTH``
        The length in bytes of data transferred on an SQLGetData, SQLFetch, or SQLFetchScroll operation if
        SQL_C_DEFAULT is specified. For numeric data, this size may be different than the size of the data
        stored on the data source. This value might be different than COLUMN_SIZE column for character data.
        For more information about length, see Column Size, Decimal Digits, Transfer Octet Length, and
        Display Size in Appendix D: Data Types.

    ``DECIMAL_DIGITS``
        The total number of significant digits to the right of the decimal point. For SQL_TYPE_TIME and
        SQL_TYPE_TIMESTAMP, this column contains the number of digits in the fractional seconds component.
        For the other data types, this is the decimal digits of the column on the data source. For interval
        data types that contain a time component, this column contains the number of digits to the right of
        the decimal point (fractional seconds). For interval data types that do not contain a time
        component, this column is 0. For more information about decimal digits, see Column Size, Decimal
        Digits, Transfer Octet Length, and Display Size in Appendix D: Data Types. NULL is returned for data
        types where DECIMAL_DIGITS is not applicable.

    ``NUM_PREC_RADIX``
        For numeric data types, either 10 or 2. If it is 10, the values in COLUMN_SIZE and DECIMAL_DIGITS
        give the number of decimal digits allowed for the column. For example, a DECIMAL(12,5) column would
        return a NUM_PREC_RADIX of 10, a COLUMN_SIZE of 12, and a DECIMAL_DIGITS of 5; a FLOAT column could
        return a NUM_PREC_RADIX of 10, a COLUMN_SIZE of 15, and a DECIMAL_DIGITS of NULL.

        If it is 2, the values in COLUMN_SIZE and DECIMAL_DIGITS give the number of bits allowed in the
        column. For example, a FLOAT column could return a RADIX of 2, a COLUMN_SIZE of 53, and a
        DECIMAL_DIGITS of NULL.

        NULL is returned for data types where NUM_PREC_RADIX is not applicable.

    ``NULLABLE``
        SQL_NO_NULLS if the column could not include NULL values.

        SQL_NULLABLE if the column accepts NULL values.

        SQL_NULLABLE_UNKNOWN if it is not known whether the column accepts NULL values.

        The value returned for this column is different from the value returned for the IS_NULLABLE column.
        The NULLABLE column indicates with certainty that a column can accept NULLs, but cannot indicate
        with certainty that a column does not accept NULLs. The IS_NULLABLE column indicates with certainty
        that a column cannot accept NULLs, but cannot indicate with certainty that a column accepts NULLs.

    ``REMARKS``
        A description of the column.

    ``COLUMN_DEF``
        The default value of the column. The value in this column should be interpreted as a string if it is
        enclosed in quotation marks.

        If NULL was specified as the default value, then this column is the word NULL, not enclosed in
        quotation marks. If the default value cannot be represented without truncation, then this column
        contains TRUNCATED, with no enclosing single quotation marks. If no default value was specified,
        then this column is NULL.

        The value of COLUMN_DEF can be used in generating a new column definition, except when it contains
        the value TRUNCATED.

    ``SQL_DATA_TYPE`` (``type``)
        SQL data type, as it appears in the SQL_DESC_TYPE record field in the IRD. This can be an ODBC SQL
        data type or a driver-specific SQL data type. This column is the same as the DATA_TYPE column, with
        the exception of datetime and interval data types. This column returns the nonconcise data type
        (such as SQL_DATETIME or SQL_INTERVAL), rather than the concise data type (such as SQL_TYPE_DATE or
        SQL_INTERVAL_YEAR_TO_MONTH) for datetime and interval data types. If this column returns
        SQL_DATETIME or SQL_INTERVAL, the specific data type can be determined from the SQL_DATETIME_SUB
        column. For a list of valid ODBC SQL data types, see SQL Data Types in Appendix D: Data Types. For
        information about driver-specific SQL data types, see the driver's documentation.

        The data types returned for ODBC 3.x and ODBC 2.x applications may be different. For more
        information, see Backward Compatibility and Standards Compliance.

    ``SQL_DATETIME_SUB``
        The subtype code for datetime and interval data types. For other data types, this column returns a
        NULL. For more information about datetime and interval subcodes, see
        "SQL_DESC_DATETIME_INTERVAL_CODE" in SQLSetDescField.

    ``CHAR_OCTET_LENGTH``
        The maximum length in bytes of a character or binary data type column. For all other data types,
        this column returns a NULL.

    ``ORDINAL_POSITION``
        The ordinal position of the column in the table. The first column in the table is number 1.

    ``IS_NULLABLE``
        "NO" if the column does not include NULLs.

        "YES" if the column could include NULLs.

        This column returns a zero-length string if nullability is unknown.

        ISO rules are followed to determine nullability. An ISO SQL–compliant DBMS cannot return an empty
        string.

        The value returned for this column is different from the value returned for the NULLABLE column.
        (See the description of the NULLABLE column.)


    """

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, TABLE_CAT, TABLE_SCHEM, TABLE_NAME, COLUMN_NAME, DATA_TYPE, TYPE_NAME, COLUMN_SIZE,
        BUFFER_LENGTH, DECIMAL_DIGITS, NUM_PREC_RADIX, NULLABLE, REMARKS, COLUMN_DEF, SQL_DATA_TYPE,
        SQL_DATETIME_SUB, CHAR_OCTET_LENGTH, ORDINAL_POSITION, IS_NULLABLE, *P ):
        super( ColumnDescription, self ).__init__()
        self.table          = None
        self._tablename     = TABLE_NAME
        self.name           = COLUMN_NAME
        self.type           = TYPE_NAME # SQL_DATA_TYPE, DATA_TYPE
        self.description    = REMARKS
        #self.additional     = P


############################################################################################################
#
#
#
#===========================================================================================================
class DatabaseDescription( DescriptionMx, SortedItervaluesDict ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, connection ):
        super( DatabaseDescription, self ).__init__()
        cursor = connection.cursor()
        #---------------------------------------------------------------------------------------------------
        cursor.tables()
        tdescResultset = cursor.fetchall()
        for tdescResult in tdescResultset:
            tdesc = TableDescription( *tdescResult )
            #print '%-20s %r (%r)' % ( tdesc.type, tdesc.name, tdesc.description, )
            self[ tdesc.name ] = tdesc
        #---------------------------------------------------------------------------------------------------
        cursor.columns()
        cdescResultset = cursor.fetchall()
        for cdescResult in cdescResultset:
            cdesc = ColumnDescription( *cdescResult )
            #print '%-20s %r (%r)' % ( cdesc.type, cdesc.name, cdesc.description, )
            table = self.get( cdesc._tablename, None )
            if table is not None:
                table[ cdesc.name ] = cdesc
                cdesc.table = table

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsCredentials ):
        """Return a ``DatabaseDescription`` instance from a ``dsCredentials``, which should be a
        dictionary-like object that contains key/value pairs suitable for calls to mxODBC's
        ``odbc.connect()`` method. A typical example::

            dsCredentials = dict(
                dsn                 = 'flowersOfGreece',
                user                = 'webuser',
                password            = 'foo',
                clear_auto_commit   = True,
                )

        """
        Q = {}
        for name in 'user', 'password', 'dsn':
            value = dsCredentials.get( name, None )
            if value is None: continue
            #   At this point we know that we are connecting via mxODBC -- hence, we also know
            #   it does not make sense to send along any Unicode characters, which would probably
            #   miserably fail using the system default encoding. For this reason, we turn everything
            #   into an 8bit string first:
            Q[ name ] = E( value )
        try:
            connection  = odbc.connect( **Q )
            return this( connection )
        except OperationalError:
            raise IOError
    fromDsCredentials = classmethod( f ); del f



############################################################################################################
#
#
#
#===========================================================================================================
def odbcDsns():
    #   From: Manuel Ruiz (mruiz@safa.es)
    #   Subject: Re: odbc dsn
    #   Newsgroups: comp.lang.python
    #   Date: 2003-01-16 07:41:52 PST
    #
    #
    #   On Thu, 16 Jan 2003 15:18:48 GMT, mruiz@safa.es (Manuel Ruiz) wrote:
    #
    #   I hope this will be useful to someone !!


    R = S()
    try:
        reg = _winreg.ConnectRegistry( None, _winreg.HKEY_LOCAL_MACHINE )
        subkey = _winreg.OpenKey( reg, r'SOFTWARE\ODBC\ODBC.INI\ODBC DATA SOURCES' )

        kinfo = _winreg.QueryInfoKey(subkey)

        for i in range(0, kinfo[1]):
            R.add( _winreg.EnumValue(subkey,i)[0] )

        _winreg.CloseKey(subkey)
        _winreg.CloseKey( reg )
    except Exception, e:
        pass

    return R




############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit(50)
    print odbcDsns()

    #dsCredentials = dict( dsn = r'Artemis', clear_auto_commit = True )
    #dsCredentials = dict( dsn = r'Pontaurus', clear_auto_commit = True )

    #   connection = odbc.DriverConnect(
    #       'Driver={SQL Server};server=localhost;Database=%(dsn)s;UID=%(user)s;PWD=%(password)s;' % dsCredentials
    #       )

    dsCredentials = dict( dsn = 'Bohlmann', user = 'sa', password = 'c', clear_auto_commit = True )
    dbDesc = DatabaseDescription.fromDsCredentials( dsCredentials )
    for tDesc in dbDesc:
        print tDesc.name
        for cDesc in tDesc:
            print '\t%s' % ( cDesc.name, )






