# -*- coding: utf8 -*-
"""
The BioCASE PyWrapper, a XML/CGI interface to heterogeneous databases

It allows a database to be queried through XML
as defined by the BioCASE Unitlevel Access Protocol schema:
BioCASE Unitlevel Access Protocol version 1.3
The resultset is also returned as a XML document.
For both querying and responding the protocol has to use some
other XML schema as a data exchange standard.

This allows an easy set up of
a distributed network of heterogeneous databases.


Contact Info:

http://www.biocase.org/
m.doering@bgbm.org

$RCSfile: __init__.py,v $
$Revision: 508 $
$Author: markus $
$Date: 2005-12-07 14:50:06 +0100 (Wed, 07 Dec 2005) $
"""

__author__ = u'Markus DÃ¶ring (m.doering@bgbm.org)'
__version__ = u'1.7.2'
__copyright__ = u'''Copyright (c) 2003 BGBM, Berlin.
See documentation for further details.'''
__license__ = u'''# Version: MPL 1.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is biocase.wrapper.
#
# The Initial Developer of the Original Code is
# M.Dï¿½ring, Botanic Garden and Botanical Museum Berlin-Dahlem.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
'''

