#!C:\Python24\python.exe
# -*- coding: UTF-8 -*-

'''
$RCSfile: dbconnection.py,v $
$Revision: 614 $
$Author: markus $
$Date: 2006-04-05 18:47:18 +0200 (Wed, 05 Apr 2006) $
The BioCASE querytool
'''

import os, sys
# ***** include the biocase.lib directory in the python sys path for importing *****
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'adjustpath.py' ) ))

from biocase.configtool.general import *


############################################################################################################
#
#   MAIN
#
#===========================================================================================================

# check authentication!
if dsa is None:
    execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), 'main.cgi' ) ))
    sys.exit()

# check authentication!
MD5Passwd = authenticate(MD5Passwd, clearPasswd, dsa)
if not MD5Passwd:
    authenticationForm(script='dbconnection.cgi', dsa=dsa)

# load html template
tmpl = PageMacro('Content', PageMacro.DELMODE)
tmpl.load('Content', os.path.join(templateDir, '_dbsettings.html'))


#
# get psfObj
#
psfObj = dsaObj.getPSFObj(tmp=False)

#
# look for new form values
#
if form.has_key('action'):
    psfObj.adminpassword = form.getfirst('adminpassword', None)
    try:
        psfObj.recLimit  = int(form.getfirst('resultlimit', None))
    except:
        log.debug( "REC LIMIT IS NO INTEGER")
    # write new PSFile
    psfObj.writePSFile()
    log.debug( "PSFile written")


#
# fill template 
#
# general stuff
tmpl['dsa'] = dsa
tmpl['id']  = MD5Passwd
tmpl['wrapper_url'] = dsaObj.getBioCASeAccessPoint()

# settings
tmpl['adminpassword'] = psfObj.adminpassword
tmpl['resultlimit']   = str(psfObj.recLimit)


#
# print HTML !
#
printOverHTTP( tmpl )
