<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes" media-type="text/html" />
    <xsl:template match="/">
                <xsl:for-each select="metadata">
                    <p><span class="label">Name: </span><xsl:for-each select="name"><xsl:apply-templates /></xsl:for-each></p>
                    <p><span class="label">Technical contact: </span><xsl:for-each select="technical_contact_name"><xsl:apply-templates /></xsl:for-each> &lt;<xsl:for-each select="technical_contact_email">
                    	<a>
                            <xsl:attribute name="href"><xsl:text disable-output-escaping="yes">mailto:</xsl:text><xsl:value-of select="." /></xsl:attribute>
                            <xsl:apply-templates />
                        </a>
                    </xsl:for-each></p>
                    <p><span class="label">Description: </span> <xsl:for-each select="description"><xsl:apply-templates /></xsl:for-each></p>
                    <p><span class="label">Notes: </span><xsl:for-each select="notes"><xsl:apply-templates /></xsl:for-each></p>
                </xsl:for-each>
    </xsl:template>
</xsl:stylesheet>
