#!C:\Python24\python.exe
# -*- coding: UTF-8 -*-

'''
$RCSfile: check_errors.cgi,v $
$Revision: 400 $
$Author: j.torre $
$Date: 2005-10-19 17:24:36 +0200 (Wed, 19 Oct 2005) $
The BioCASE TestingTool
'''

#Import some stuff-----------------------------------------
import cgitb; cgitb.enable()
import cgi
import string
import os, sys
import inspect as               _i
import os as                    _os
import os.path as               _p
import urllib
import libxml2
#-----------------------------------------------------------------------------------------------------------
#   See fundamentals things being done -- this will, inter alia, put g.callCgi into the global namespace:
execfile( os.path.abspath(os.path.join(os.path.dirname( __file__ ), os.path.pardir, os.path.pardir, 'lib', 'biocase', 'fundamentals.py' ) ) )
#-------------------------------------------------------------
import biocase.configuration
from biocase.querytool.querydispatcher import QueryDispatcher
from biocase.tools.xmllibtools import transformXML

# get config data
cfg=biocase.configuration.Cfg()

# Take parameters
form = cgi.FieldStorage()

#------------------------------------------------------------------------------------

#First query the wrapper with the XML sent
wrapper_url = cfg.PyWrapperURL + '?dsa=' +  form['dsa'].value
protocolXML = form['search'].value

params = urllib.urlencode({'query': protocolXML, 'debug':form['debug'].value})
f = urllib.urlopen(wrapper_url, params)
content=f.read()
contentDOM = libxml2.parseDoc(content)


#Transform the result using the analizing xslt
here = _p.abspath( _p.dirname( _i.getfile( lambda:None ) ) ) 
xsl_path = _p.join( here, _os.pardir, 'resources', 'xsl', 'Analize_errors.xsl')
xml_path = _p.join( here, _os.pardir, 'configuration', 'datasources', form['dsa'].value, 'metadata.xml')
paras = ""
debug = ""

stylesheetResult = transformXML(docDOM=contentDOM, xslLoc=xsl_path)


#Print the headers	
print 'Content-Type: text/html; charset=UTF-8'
print # Blank line marking end of HTTP headers
print stylesheetResult

#print content