#!C:\Python24\python.exe
# -*- coding: UTF-8 -*-

'''
$RCSfile: index.cgi,v $
$Revision: 582 $
$Author: j.torre $
$Date: 2006-03-27 11:30:52 +0200 (Mon, 27 Mar 2006) $
The BioCASE TestingTool
'''

#Import some stuff-----------------------------------------
import cgitb; cgitb.enable()
import string
import os, sys
import inspect as               _i
import os as                    _os
import os.path as               _p
import cgi
#-----------------------------------------------------------------------------------------------------------
#   See fundamentals things being done -- this will, inter alia, put g.callCgi into the global namespace:
execfile( os.path.abspath(os.path.join(os.path.dirname( __file__ ), os.path.pardir, os.path.pardir, 'lib', 'biocase', 'fundamentals.py' ) ) )
#-------------------------------------------------------------
import biocase.tools.templating
from biocase.tools.htmltools import getDropDownOptionHtml
import biocase.configuration
import biocase.datasources

# get config data
cfg=biocase.configuration.Cfg()
#Get the dsa parameter
form = cgi.FieldStorage()

#------------------------------------------------------------------------------------

#Prepare the template
pm = biocase.tools.templating.PageMacro('Content', biocase.tools.templating.PageMacro.KEEPMODE)
pm.load('Content', os.path.join(cfg.wwwLocator,'testingtool', '_index.html'))


#Check that all necesary libraries are installed:
try:
	import _xmlplus
	import libxml2
	import mx.DateTime
	import biocase
	import biocase.wrapper
	pm['library_status'] = '<span class="goodstatus">OK</span>'
except:
	pm['library_status'] = '<span class="badstatus">Wrong, </span><a href="../utilities/testlibs.cgi">check libraries</a>'

#Print the headers	
print 'Content-Type: text/html; charset=UTF-8'
print # Blank line marking end of HTTP headers

dsaList = biocase.datasources.getDsaList()
if form.has_key('dsa'):
    dsa = form['dsa'].value
    dsaObj = biocase.datasources.Datasource(dsa)
else:
    # take first one from list
    dsaObj = dsaList[0]
    dsa = dsaObj.name
pm['dsa'] = dsa
pm['DataSourcesOptionList'] = getDropDownOptionHtml([d.name for d in dsaList], default=dsa)
    
#Check that the database connection is fine
pm['db_con'] = dsaObj.getDBConnectionStatus()

print pm
