#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   FUNDAMENTALS ENABLER
#
#===========================================================================================================
try:                g
except NameError:   import _biocaseFundamentalsCaller

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
_EzClassMc                              = u.EzClassMc.EzClassMc
_fsi                                    = u.filesystemIdioms
#-----------------------------------------------------------------------------------------------------------


############################################################################################################
#
#
#
#===========================================================================================================
class DatasourceDescriptor:
    __metaclass__   = _EzClassMc
    __obligatory__  = """name type locator""".split()
    __slots__ = True


############################################################################################################
#
#
#
#===========================================================================================================
class getDatasourceDescriptors( object ):

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        """Return a list of existing data source alias directories."""
        datasourcesLocator = g.cfg.datasourcesLocator
        filter = lambda locator: not locator.endswith( '/CVS' ) ## hack
        for R in _fsi.iterateNameLocatorPairsOfDirectories( datasourcesLocator, filter = filter ):
            yield R
    iterDsaliasLocatorPairs = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        for gauge, locator in this.iterDsaliasLocatorPairs():
            yield DatasourceDescriptor(
                name            = gauge,
                type            = 'datasource',
                locator         = locator,
                )
    iterDatasourceDescriptors = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        R = [ ( description.name.lower(), description )
            for description in this.iterDatasourceDescriptors() ]
        R.sort()
        for name, description in R:
            yield description
    iterDatasourceDescriptorsSorted = classmethod( f ); del f


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    sep = '#' * 108

    print g.cfg._asTable()

    for description in getDatasourceDescriptors.iterDatasourceDescriptorsSorted():
        print description

