#
# -*- coding: utf-8 -*-

"""Provides a solitaire class, ``Misfit``, that can be used to indicate unacceptable or missing values
in cases where ``None`` would be insufficient."""


class Misfit:
    """A solitaire class-cum-instance that signals an unacceptable or missing value; it replaces
    ``None`` where that must be considered an acceptable value."""
    __unicode__ = __str__ = __repr__ = lambda self: '<###MISFIT###>'

Misfit = Misfit()

