#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   IMPORTS AND CONSTANTS
#
#===========================================================================================================
import  cgi
import  sys
import  traceback
import  inspect
#-----------------------------------------------------------------------------------------------------------

############################################################################################################
#
#
#
#===========================================================================================================
def _getTracebackReport( e ): # copied from cgi.py
    try:
        R = []
        #-------------------------------------------------------------------------------------------------------
        type, value, tb = sys.exc_info()
        limit = None
        R.append( 'Traceback (most recent call last):' )
        tracebacks = traceback.format_tb( tb, limit ) + traceback.format_exception_only( type, value )
        R.append( ''.join( tracebacks[ : -1 ] ) )
        R.append( tracebacks[ -1 ] )
    finally:
        del tb
    return '\n'.join( R )

############################################################################################################
#
#
#
#===========================================================================================================
def print_exception( e ): # copied from cgi.py
    try:
        #-------------------------------------------------------------------------------------------------------
        #   try:
        #       eClassName = e.__class__.__name__
        #   except AttributeError:
        #       eClassName = '<Unknown Exception Class>'
        #-------------------------------------------------------------------------------------------------------
        #print '<hr><div style="color:red;">%s: %s<br>' % ( eClassName, e )
        print '<hr><div style="color:red;">'
        #-------------------------------------------------------------------------------------------------------
        type, value, tb = sys.exc_info()
        limit = None
        print '<pre>Traceback (most recent call last):'
        tracebacks = traceback.format_tb( tb, limit ) + traceback.format_exception_only( type, value )
        print "%s<b>%s</b>" % (
            cgi.escape( "".join( tracebacks[ : -1 ] ) ),
            cgi.escape( tracebacks[ -1 ] ),
            ),
        #print '</pre>'
        print '</div><hr>'
    finally:
        del tb


#===========================================================================================================
def printCgiinfo():
    #-------------------------------------------------------------------------------------------------------
    ll = 108
    sep0 = '=' * ll
    sep1 = '-' * ll
    fs = '%-22s = %s'
    #-------------------------------------------------------------------------------------------------------
    print '<pre style="font-size:90%;">'
    #-------------------------------------------------------------------------------------------------------
    print sep0
    print "This is %s" % ( inspect.getsourcefile( lambda:None ) )
    print sep0
    #-------------------------------------------------------------------------------------------------------
    print fs % ( 'sys.argv', sys.argv )
    #-------------------------------------------------------------------------------------------------------
    print sep1
    print 'sys.path:'
    for i, entry in enumerate( sys.path ):
        print fs % ( i, entry.replace( '\\', '/' ) )
    #-------------------------------------------------------------------------------------------------------
    print sep1
    names = os.environ.keys()
    names.sort()
    for name in names:
        print fs % ( name, os.environ[ name ] )
    print '</pre>'
    #-------------------------------------------------------------------------------------------------------
#__cgiinfo__()
