#
# -*- coding: utf-8 -*-


#-----------------------------------------------------------------------------------------------------------
_xmlIdioms                  = g._xmlIdioms
h                           = g.hm.h
widgets                     = g.widgets
#   from    configtool.utilities.htmlMaker.htmlMaker        import                      h
#   from    configtool.utilities.htmlMaker                  import                      widgets
#   from    configtool.utilities                            import xmlIdioms    as      _xmlIdioms
#-----------------------------------------------------------------------------------------------------------

############################################################################################################
#
#
#
#===========================================================================================================
def nodeAsInput( node, lbl_text = None, inp_name = None, index = None, indexOfNewEntry = None ):
    """"""
#       if node is None:
#           inp_text = ''
#           if inp_name is None: inp_name = '***UNKNOWN***'
#           index = '_new'
#       else:
#           inp_text = _xmlIdioms.getText_DEPRECATED_( node )
#       #-------------------------------------------------------------------------------------------------------
#       if index     is not None: inp_name = '%s%s' % ( inp_name, index )
#       if lbl_text  is     None: lbl_text = inp_name
#       #-------------------------------------------------------------------------------------------------------

#       if name  is     None: name = node.nodeName
#       if index is not None: name = '%s%s' % ( name, index )
#       if text  is     None: text = name
    #-------------------------------------------------------------------------------------------------------
    if inp_name  is     None: inp_name = node.nodeName
    if index is not None and index == indexOfNewEntry: index = '_NEW_'
    if index     is not None: inp_name = '%s%s' % ( inp_name, index )
    if lbl_text  is     None: lbl_text = inp_name
    inp_text = _xmlIdioms.getText_DEPRECATED_( node )
    #-------------------------------------------------------------------------------------------------------

    return widgets.LabelledInput(
            lbl_text = lbl_text,
            inp_name = inp_name,
            inp_text = inp_text,
            )

class LeaveAsIs:
    def __init__( self, value ):
        self.value = value

#===========================================================================================================
def nodeAsDropdown( node, options ):
    """"""
    return widgets.LabelledDropdown(
            lbl_text = node.nodeName,
            inp_name = node.nodeName,
            inp_options = options,
            )


#===========================================================================================================
def setTextFromQuery( node, query, fieldname ):
    """Set value of text below ``node`` from named value ``fieldname`` found in ``query``, which should be a
    ``cgi.FieldStorage`` instance."""
    value = query.getfirst( fieldname, None )
    if value is not None:
        _xmlIdioms.getTextNode_DEPRECATED_( node ).nodeValue = value





