#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   FUNDAMENTALS ENABLER
#
#===========================================================================================================
try:                g
except NameError:   import _biocaseFundamentalsCaller

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
#import os
import libxml2 as                       _libxml2
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
#   _S                                      = u.EzSet.S
#-----------------------------------------------------------------------------------------------------------

############################################################################################################
#
#
#
#===========================================================================================================
class libxml2Idioms( object ):

    #-------------------------------------------------------------------------------------------------------
    def f( this, text ):
        return ' '.join( text.strip().split() )
    normalize = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, node, name ):
        xpathExpression = './@%s' % ( name, ) # apply UTF-8 conversion first
        R = None
        try:
            R = node.xpathEval( xpathExpression )
        except:
            raise #pass
        if not R:
            raise 'XXXXXXXXXXXX'
        return R[ 0 ]
    getAttribute = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, node, name ):
        return this.normalize( this.getAttribute( node, name ).content )
    getAttributeValue = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, node, name ):
        return this.normalize( node.prop( name ) )
    getAttributeValue2 = classmethod( f ); del f

    #=======================================================================================================
    class getDocument( object ):

        #---------------------------------------------------------------------------------------------------
        def f( this, filelocator ):
            return _libxml2.parseFile( filelocator )
        forFilelocator = classmethod( f ); del f

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    _EzGraph                                = u.EzGraph
    cmfHomelocator                          = r'../biocase-internal/metakit'


    filename = r'cmf_ABCD_1.20_empty.xml'
    #filename = r'cmf_KeywordTransfer_1.0_empty.xml'
    filelocator = _p.abspath( _p.join( g.cfg.homeLocator, cmfHomelocator, filename ) )

    graph = _EzGraph.Graph( 'abcd12' )

    cmfi = u.PsfCmfIdioms.CmfIdioms
    locators = list( cmfi.iterConceptLocatorsForFilelocator( filelocator ) )
    locators.sort()
    for locator in locators:
        #parentLocator
        graph.newNodeForLocator( locator )

    for node in graph:
        print node.name



