#!C:\Python24\python.exe
# -*- coding: utf-8 -*-

# ***** include the biocase.lib directory in the python sys path for importing *****
import os, sys
execfile( os.path.abspath(os.path.join(os.path.dirname( __file__ ), os.path.pardir, os.path.pardir, 'lib', 'biocase', 'adjustpath.py' ) ) )

import cgitb; cgitb.enable()
import string
from biocase.configuration import Cfg

cfg = Cfg('configtool')

print 'Content-Type: text/html'
print # Blank line marking end of HTTP headers

print '''<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Python library tests</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/css/biocase.css" rel="stylesheet" type="text/css">
<link rel="SHORTCUT ICON" href="../resources/images/favicon.ico">
</head>

<body>

<!-- HEADER -->
<div id="Header">
Python Library Tests
</div>
<div id="NavBar"><a href="../index.cgi">Start</a> <span class="breadcrumbSeparator">&raquo;</span> <a href="index.html">Utilities</a> <span class="breadcrumbSeparator">&raquo;</span><strong>Test libraries</strong> </div>

<div id="Content">

<h2>Python Interpreter: %s </span></h2>''' % string.join([str(i) for i in sys.version_info[:3]],".")

print '''<span class="goodstatus">green:</span> Ok! | <span class="badstatus">red:</span> you have to install it | <span class="dependstatus">orange:</span> install the one for your database 

<!-- START REQUIRED LIBS TABLES -->
<h2>Status of required Python libraries</h2>
      <table>
        <tr > 
          <th width="120"><strong>Library</strong></th>
          <th width="120"><strong>Installed Version</strong></th>
          <th width="360"><strong>Download Library</strong></th>
        </tr>'''

# PyXML
print '''        <tr > 
          <td>PyXML</td>
          <td>'''        
try:
    import _xmlplus
    print '<span class="goodstatus">' + _xmlplus.__version__ + '</span>'
except:
    print '<span class="badstatus">not installed</span>'

print '''
</td>
          <td><a href="http://pyxml.sourceforge.net/">PyXML</a></td>
        </tr>'''

# libxml2
print '''        <tr > 
          <td>libxml2</td>
          <td>'''        
try:
    import libxml2
    print '<span class="goodstatus">installed</span>'
except:
    print '<span class="badstatus">not installed</span>'

print '''
</td>
          <td><a href="http://xmlsoft.org/python.html">libxml2</a>
          (<a href="http://users.skynet.be/sbi/libxml-python/">win</a> <a href="http://jamesclarke.info/notes/InstallLibxml2">mac</a> <a href="http://garypennington.net/libxml2/">solaris</a>)
          </td>
        </tr>'''
        
# libxslt1
print '''        <tr > 
          <td>libxslt</td>
          <td>'''        
try:
    import libxslt
    print '<span class="goodstatus">installed</span>'
except:
    print '<span class="badstatus">not installed</span>'

print '''
</td>
          <td>libxslt is part of the libxml2 distribution above
          </td>
        </tr>'''

# mxDateTime
print '''
        <tr > 
          <td>mxDateTime</td>
          <td>'''
try:
    import mx.DateTime
    print '<span class="goodstatus">' + mx.DateTime.__version__ + '</span>'
except:
    print '<span class="badstatus">not installed</span>'

print '''</td>
            <td><a href="http://www.egenix.com/files/python/eGenix-mx-Extensions.html#Download-mxBASE">mxDateTime</a></td>
        </tr>'''

# HTML
print'''
    </table>   
<h4>&nbsp;</h4>
<h2>Status of bundled libraries:</h2>
      <table>
        <tr > 
          <th width="120"><strong>Library</strong></th>
          <th width="120"><strong>Installed Version</strong></th>
          <th width="360"><strong>Download Library</strong></th>
        </tr>
'''

# metakit
print '''
        <tr > 
          <td>metakit</td>
          <td>'''
try:
    import biocase.configtool.utilities.metakit.Mk4py as mk
    print '<span class="goodstatus">' + mk.version + '</span>'
except:
    print '<span class="badstatus">not installed</span>'

print '''</td>
            <td><a href="http://www.equi4.com/pub/mk/">metakit</a></td>
        </tr>'''


# biocase libs
print '''
        <tr > 
          <td>BioCASE lib</td>
          <td>'''
try:
    import biocase
    print '<span class="goodstatus">' + biocase.__version__ + '</span>'
except:
    print '<span class="badstatus">not installed</span>'

print '''</td>
            <td>BioCASE libs</td>
        </tr>'''

# biocase wrapper libs
print '''
        <tr > 
          <td>PyWrapper</td>
          <td>'''
try:
    import biocase.wrapper
    print '<span class="goodstatus">' + biocase.wrapper.__version__ + '</span>'
except:
    print '<span class="badstatus">not installed</span>'

print '''</td>
            <td>BioCASE PyWrapper</td>
        </tr>'''


# HTML
print '''
    </table>

<!-- START DRIVER TABLES -->
<h4>&nbsp;</h4>
<h2>Status of additional database dependent drivers:</h2>
      <table>
        <tr > 
          <th width="120"><strong>Library</strong></th>
          <th width="120"><strong>Installed Version</strong></th>
          <th width="360"><strong>Download Library</strong></th>
        </tr>'''
        
# mxODBC
print '''        <tr > 
          <td>mxODBC</td>
          <td>'''
try:
    import mx.ODBC
    print '<span class="goodstatus">' + mx.ODBC.__version__ + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'

print '''</td>
            <td><a href="http://www.egenix.com/files/python/eGenix-mx-Extensions.html#Download-mxCOMMERCIAL">ODBC module</a></td>
        </tr>'''
        
# pymssql
print '''<!--        <tr > 
          <td>pymssql</td>
          <td>'''
try:
    import pymssql
    print '<span class="goodstatus">' + pymssql.__version__ + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'

print '''</td>
            <td>
            <a href="http://pymssql.sourceforge.net/">MS SQL Server module (unix/win)</a></td>
        </tr>
        -->'''
        
# pyPgSQL
print '''
        <tr > 
          <td>pyPgSQL</td>
          <td>'''
try:
    import pyPgSQL
    print '<span class="goodstatus">' + pyPgSQL.__version__ + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'
          
print '''</td>
            <td><a href="http://pypgsql.sourceforge.net">PostgreSQL module</a></td>
        </tr>'''


# psycopg
print '''
        <tr > 
          <td>psycopg</td>
          <td>'''
try:
    import psycopg
    print '<span class="goodstatus">' + psycopg.__version__ + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'
          
print '''</td>
            <td><a href="http://initd.org/software/initd/psycopg">Alternative PostgreSQL module</a> - <a href="http://stickpeople.com/projects/python/win-psycopg/">win binaries</a></td>
        </tr>'''


# MySQLdb
print '''
        <tr > 
          <td>MySQLdb</td>
          <td>'''
try:
    import MySQLdb
    print '<span class="goodstatus">' + MySQLdb.__version__ + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'
          
print '''</td>
            <td><a href="http://sourceforge.net/projects/mysql-python/">mySQL module</a></td>
        </tr>'''


# cx_Oracle
print '''
        <tr > 
          <td>cx_Oracle</td>
          <td>'''
try:
    import cx_Oracle
    print '<span class="goodstatus">' + cx_Oracle.version + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'
          
print '''</td>
            <td><a href="http://www.cxtools.net/default.aspx?nav=cxorlb">Oracle 8-9 module</a>, you also need the <a href="http://otn.oracle.com/software/content.html">Oracle Client</a></td>
        </tr>'''


# kinterbasdb
print '''
        <tr > 
          <td>kinterbasdb</td>
          <td>'''
try:
    import kinterbasdb
    print '<span class="goodstatus">' + string.join([str(x) for x in kinterbasdb.__version__], ".") + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'
          
print '''</td>
            <td><a href="http://kinterbasdb.sourceforge.net/">Firebird/Interbase module</a></td>
        </tr>'''



# SQLlite
print '''
        <tr > 
          <td>SQLlite</td>
          <td>'''
try:
    import sqlite
    print '<span class="goodstatus">' + sqlite.version + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'
          
print '''</td>
            <td><a href="http://initd.org/tracker/pysqlite">pySQLite module</a></td>
        </tr>
'''

# Sybase
print '''
        <tr > 
          <td>sybase</td>
          <td>'''
try:
    import sybase
    print '<span class="goodstatus">' + sybase.__version__ + '</span>'
except:
    print '<span class="dependstatus">not installed</span>'
          
print '''</td>
            <td><a href="http://www.object-craft.com.au/projects/sybase/">Sybase module</a></td>
        </tr>
</table>        
'''



# DETECT GRAPHVIZ, external binaries
if cfg.configtool.graphviz_dot is not None and os.path.isfile(cfg.configtool.graphviz_dot):
    graphviz_status = '<span class="goodstatus">%s</span>' % "Binary found"
else:
    graphviz_status = '<span class="badstatus">%s</span>' % "Binary not found"

print '''
<h4>&nbsp;</h4>
<h2>Optional external binaries:</h2>
      <table>
        <tr > 
          <th width="120"><strong>Binary</strong></th>
          <th width="120"><strong>Status</strong></th>
          <th width="360"><strong>Path</strong></th>
        </tr>
        <tr > 
          <td>%s</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
      </table>          
''' %('<a href="http://www.graphviz.org/Download.php">Graphviz Dot</a>', graphviz_status, cfg.configtool.graphviz_dot)




#
#Detect if the configuration and log folders are writable rescursively.
#
def folder_not_writable(path, verbose=False):
    '''Returns "---" if folder is writable 
    or the absolute path of the directory or file that is not writable.'''
    
    for root, dirs, files in os.walk(path):
        if verbose:
            print "<br>-->walk dir: %s"%(root)
        # check directories by creating a test dummy file
        for name in dirs:
            fn = os.path.join(root, name, 'dummy1973TestomatKarambolaIggI')
            try:
                f = file(fn, 'a')
            except:
                if verbose:
                    print "<br><strong>DIR %s IS NOT WRITABLE !!!</strong>"%(fn)
                return os.path.join(root, name)
            f.close()
            os.unlink(fn)
            if verbose:
                print "<br>dir %s is writable."%( os.path.join(root, name) )
        # check if files are writable by opening them for appending
        for name in files:
            fn = os.path.join(root, name)
            try:
                f = file(fn, 'a')
            except:
                if verbose:
                    print "<br><strong>FILE %s IS NOT WRITABLE !!!</strong>"%(fn)
                return fn
            if verbose:
                print "<br> file %s is writable."%(fn)
    return None


statusCfg = folder_not_writable(cfg.configurationLocator)
if statusCfg is None:
    config_folder_writable_status = '<span class="goodstatus">Writeable</span>'
else:
    config_folder_writable_status = '<span class="badstatus">Unwriteable</span>'

statusLog = folder_not_writable(cfg.logLocator)
if statusLog is None:
    log_folder_writable_status = '<span class="goodstatus">Writeable</span>'
else:
    log_folder_writable_status = '<span class="badstatus">Unwriteable</span>'


# HTML
print '''
<h4>&nbsp;</h4>
<h2>Status of writable directories and files:</h2>
      <table>
        <tr > 
          <th width="120"><strong>Directory</strong></th>
          <th width="120"><strong>Status</strong></th>
          <th width="360"><strong>Path to problematic file</strong></th>
        </tr>
        <tr > 
          <td>Configuration</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
        <tr > 
          <td>Log</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
      </table>          
''' %(config_folder_writable_status, str(statusCfg), log_folder_writable_status, str(statusLog))
        
print '''
</div>

<!-- FOOTER -->

<div id="Footer"> 
  <a href="http://www.biocase.org"><img src="../resources/images/biocase_powered.gif" width="112" height="34"></a> 
</div>

</body>
</html>
'''
